import { AxiosResponse } from 'axios';

export declare class ActionCard extends MessageTemplateAbs {
    title: string;
    text: string;
    hideAvatar: number;
    btnOrientation?: number;
    singleTitle: string;
    singleURL: string;
    btns: {
        title: string;
        actionURL: string;
    }[];
    constructor();
    setBtns(btns: ConcatArray<{
        title: string;
        actionURL: string;
    }>): this;
    setSingleTitle(title: string): this;
    setSingleURL(url: string): this;
    setTitle(title: string): this;
    setText(content: string): this;
    setBtnOrientation(flag: number): this;
    setHideAvatar(flag: number): this;
    get(): any;
}

export declare class FeedCard extends MessageTemplateAbs {
    links: Link[];
    constructor(links: Link[]);
    addLinks(links: Link[]): this;
    get(): any;
}

export declare class Link extends MessageTemplateAbs {
    title: string;
    messageUrl: string;
    picUrl?: string;
    text: string;
    constructor(content: any);
    setContent(content: string): this;
    setTitle(title: string): this;
    setImage(image: string): this;
    setUrl(url: string): this;
    get(): any;
}

export declare class Markdown extends MessageTemplateAbs {
    items: string[];
    title: string;
    constructor();
    setTitle(title: string): this;
    add(text: string | string[]): this;
    get(): any;
}

export declare type Message = MessageTemplateAbs | ActionCard | FeedCard | Link | Markdown | Text_2;

export declare class MessageTemplateAbs {
    canAt: boolean;
    isAtAll: boolean;
    atMobiles: Set<string>;
    atDingtalkIds: Set<string>;
    msgtype: string;
    constructor();
    render(options: any): any;
    get(): void;
    toJsonString(): void;
    atAll(): this;
    atPhone(phones: string | string[]): this;
    atId(ids: string | string[]): this;
}

export declare class Robot {
    private accessToken?;
    private secret?;
    private webhook;
    constructor(option?: RobotOption);
    private getSign;
    private request;
    send(message: Message): Promise<AxiosResponse<any> | undefined>;
}

declare class RobotOption {
    accessToken?: string;
    secret?: string;
}

declare class Text_2 extends MessageTemplateAbs {
    content: string;
    constructor(content: string);
    setContent(content: string): this;
    get(): any;
}
export { Text_2 as Text }

export { }
